/**
 * Created by knifhen on 20/10/15.
 */
var logger = require('sa-logger');
var TournamentDAO = function (client) {
    this.client = client;
};
module.exports = TournamentDAO;
var TOURNAMENTS_KEY = 'Tournaments';
TournamentDAO.prototype = {
    get: function (tournamentId, callback) {
        var self = this;
        self.client.exists(TOURNAMENTS_KEY, function (err, result) {
            if (err) {
                logger.error(err);
                return callback(err);
            }
            if (result) {
                self.client.hget(TOURNAMENTS_KEY, tournamentId, function (err, reply) {
                    if (err) {
                        return callback(err);
                    }
                    if (reply == null) {
                        return callback(null, null);
                    }
                    callback(null, JSON.parse(reply));
                });
            }
            else {
                self.client.get(tournamentId, function (err, reply) {
                    if (err) {
                        return callback(err);
                    }
                    if (reply == null) {
                        return callback(null, null);
                    }
                    callback(null, JSON.parse(reply));
                });
            }
        });
    },
    set: function (tournamentId, tournament, callback) {
        var self = this;
        self.client.exists(TOURNAMENTS_KEY, function (err, result) {
            if (err) {
                logger.error(err);
                return callback(err);
            }
            if (result) {
                self.client.hset(TOURNAMENTS_KEY, tournamentId, JSON.stringify(tournament), callback);
            }
            else {
                self.client.set(tournamentId, JSON.stringify(tournament), callback);
            }
        });
    }
};
